#!/bin/ksh
# Licensed Materials - Property of IBM
# 5724-S67
# (c) Copyright IBM Corp. 1998, 2010   All Rights Reserved.
# US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
export LC_TIME="C"

ACTUATOR_LOG=../log/$PROPSFILE.log
TEMPFILE=$TEMPFILE2
SHARED_SCRIPT=../bin/getguardium_shared.sh
ERRORFILE=$PROPSFILE.err
LOGTYPE="EXCEPTION"

##################### INTERNAL FUNCTIONS #######################
function printlog {
 echo `date "+%a %D %T"` $1 >> $ACTUATOR_LOG
}

function increaseerr {
 NUM=`cat $ERRORFILE` && ((NUM += 1)) && echo $NUM > $ERRORFILE
}
##################### INTERNAL FUNCTIONS #######################

# Check log template
if [ "a$OPTION4" = "a" ] ; then 
 printlog "WARNING: Exception tracking log filename template is not defined. Skipping."
 increaseerr
 > $TEMPFILE
 exit 0
fi

# Now we start with 2st sublog processing
printlog "Processing exception tracking sublog (#2)"
$SHARED_SCRIPT $TEMPFILE $OPTION4 $LOGTYPE $OPTION2 $PROPSFILE

if [[ $? -eq 0 ]] ; then
 printlog "Exception tracking sublog collect: SUCCESS"
else
 printlog "ERROR: Exception tracking sublog collect: FAILURE"
 printlog "Will try to collect other sublogs."
 increaseerr
fi

printlog "========================================================"

exit 0
