#!/bin/ksh

LANG=C

if [ -z "$PROPSFILE" ]; then
   ES_LOG="../log/getitfimlogs-error.log"
   echo "[`date`] ERROR: Missing property file argument"> $ES_LOG
   echo "[`date`] Processing finished [FAILURE].">> $ES_LOG
   touch "$TEMPFILE1" "$TEMPFILE2"
   exit 1
fi
[ -f "$PROPSFILE" ] || touch "$PROPSFILE"

PROPS_NAME=`basename $PROPSFILE`
PROPS_NAME=${PROPS_NAME%.*}
ACTUATOR_LOG="../log/${PROPS_NAME}.log";
PROPS_TEMP="${PROPSFILE}.new";
EXITCODE_FILE="itfim.failure"
JAVAPATH_FILE="java.path"
echo $OPTION4 > $JAVAPATH_FILE
export LANG PROPS_NAME ACTUATOR_LOG PROPS_TEMP JAVAPATH_FILE

echo "[`date`] Processing started." > $ACTUATOR_LOG
[ -f $PROPS_TEMP ] && rm -f $PROPS_TEMP
[ -f $EXITCODE_FILE ] && rm -f $EXITCODE_FILE
[ -f $JAVAPATH_FILE ] && rm -f $JAVAPATH_FILE

../bin/getitfim_shared62.sh "$TEMPFILE1" "$OPTION3" "$OPTION5" "Management"
RESULT_CODE=$?

if [ $RESULT_CODE -eq 3 ]; then
   exit 1
else
   # indicate for runtime part that management collect was NOT SUCCESS
   [ $RESULT_CODE -ne 0 ] && echo "$RESULT_CODE" > $EXITCODE_FILE
fi

exit 0
