@echo off
set TEMPFILE1=%~1
set DBTYPE=%~3
set DBNAME=%~4
set DBSCHEMA=%~5
set PORT=%~6
set USERNAME=%~7
set PASSWORD=%~8
for %%I in (%*) do set PROPSFILE=%%~I

rem -- sets actuator log name
if "%PROPSFILE%" == "" (
   set ACTUATOR_LOG="..\log\gettamessologs.err"
) else (
   set ACTUATOR_LOG="..\log\%PROPSFILE%.log"
)

echo [%date%][%time%] Processing started. >%ACTUATOR_LOG% 2>&1

if "%TEMPFILE1%" == "" (
    echo [%date%][%time%] temporary file 1 location is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

rem defining DBHOST
for /F "tokens=1,2 delims='='" %%i in (%PROPSFILE%) do ( 
   if "%%i"=="SystemName" (
     for /F "tokens=1,2 delims= " %%a in ('echo %%j') do (
        set DBHOST=%%a
       )
     )
     
   if "%%i"=="SystemName " (
     for /F "tokens=1,2 delims= " %%a in ('echo %%j') do (
        set DBHOST=%%a
       )
     ) 
   )
   
if "%DBHOST%" == "" (
    echo [%date%][%time%] Database host is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)
echo %DBHOST% | findstr /R "[!()\/@*&$*]" > nul
if %ERRORLEVEL% EQU 0 (
    echo [%date%][%time%] Hostname contains illegal characters. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

if "%PORT%" == "" (
    echo [%date%][%time%] Database port is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)
echo %PORT% | findstr /R "[!()\/@*&$*A-Za-z]" > nul
if %ERRORLEVEL% EQU 0 (
    echo [%date%][%time%] Port contains illegal characters. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

if "%DBNAME%" == "" (
    echo [%date%][%time%] Database name is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

if "%USERNAME%" == "" (
    echo [%date%][%time%] User name is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

if "%PASSWORD%" == "" (
    echo [%date%][%time%] Password is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

if "%DBSCHEMA%" == "" (
    echo [%date%][%time%] Database schema is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

set DBTYPE_OK=0
if "%DBTYPE%" == "DB2" (
    echo [%date%][%time%] Database type is %DBTYPE%. >>%ACTUATOR_LOG% 2>&1
    set DBTYPE_OK=1
)
if "%DBTYPE%" == "Oracle" (
    echo [%date%][%time%] Database type is %DBTYPE%. >>%ACTUATOR_LOG% 2>&1
    set DBTYPE_OK=1
)
if "%DBTYPE%" == "MS SQL" (
    echo [%date%][%time%] Database type is %DBTYPE%. >>%ACTUATOR_LOG% 2>&1
    set DBTYPE_OK=1
)
if "%DBTYPE_OK%" == "0" (
    echo [%date%][%time%] Wrong database type is specified. Using DB2 by default. >>%ACTUATOR_LOG% 2>&1
    set DBTYPE=DB2
)

if "%PROPSFILE%" == "" (
    echo [%date%][%time%] Propsfile is not specified. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

echo [%date%][%time%] Checking Java binary availability. >>%ACTUATOR_LOG% 2>&1
where java > nul 2>&1
if %ERRORLEVEL% EQU 1 (
    echo [%date%][%time%] Java binary is not found. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

echo SELECT attrValue, roleDescription from (SELECT MAX(roleID) as maxrole, attrValue from (SELECT attrValue, roleID from %DBSCHEMA%.IMSIdentityRole inner join %DBSCHEMA%.IMSIdentityUniqueAttribute on %DBSCHEMA%.IMSIdentityRole.imsID = %DBSCHEMA%.IMSIdentityUniqueAttribute.imsID where %DBSCHEMA%.IMSIdentityUniqueAttribute.attrName='Enterprise Login') alias GROUP BY attrValue) alias, %DBSCHEMA%.IMSRole where maxrole=roleID > IMSRoles_%PROPSFILE%.sql

echo [%date%][%time%] Collecting IMSLOGUserActivity table. >>%ACTUATOR_LOG% 2>&1
java -Dfile.encoding=UTF-8 -classpath "%JDBCDRIVERPATH%;../bin/jdbc-genact.jar" eprise.audit.chunktool.generic.java.JdbcGenact -driver="%DBTYPE%" -host="%DBHOST%" -port="%PORT%" -database="%DBNAME%" -username="%USERNAME%" -passwd="%PASSWORD%" -props="%PROPSFILE%" -outfilename="%PROPSFILE%.db_groups" -sqlfilename="IMSRoles_%PROPSFILE%.sql" -useheaderline=no  -separator=";" -eraseoutfile=yes >>%ACTUATOR_LOG% 2>&1
if %ERRORLEVEL% NEQ 0 (
    echo [%date%][%time%] Error quering database. >>%ACTUATOR_LOG% 2>&1
    echo [%date%][%time%] Processing finished [FAILURE]. >>%ACTUATOR_LOG% 2>&1
    exit /b 1
)

if exist "%PROPSFILE%.db_groups" (
echo [SourceGroup] > %PROPSFILE%.db
rem echo [%date%][%time%] Collecting groups within administrative roles. >> %LOG_FILE%
for /F "tokens=1,2,3 delims=;" %%i in ('type %PROPSFILE%.db_groups') do (
      echo "%%k role" >> %PROPSFILE%.db
      echo { >> %PROPSFILE%.db
      echo   match logonname "%%j" >> %PROPSFILE%.db
      echo } >> %PROPSFILE%.db
     )
)
copy %PROPSFILE%.db %TEMPFILE1% >nul 2>&1

echo [%date%][%time%] Clearing temporary files. >>%ACTUATOR_LOG% 2>&1
del IMSRoles_%PROPSFILE%.sql
del %PROPSFILE%.db_groups
del %PROPSFILE%.db

echo [%date%][%time%] Processing finished [SUCCESS]. >>%ACTUATOR_LOG% 2>&1
exit /b 0

